//gdat.c

#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <semaphore.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include "gdat.h"

pthread_mutex_t         	gdmemMutex;
pthread_t               	hgdmemnProcess;
sem_t 				*sem;
GDATA1 				*addr;
GDATA1 				gdat;
int 				shm;
uint64_t			timeSonar;


//старт доступа к разделякмой памяти
int	gdmemstart(void)
{
	//память - создание
	if ( (shm = shm_open(gdatSHARED_MEMORY_OBJECT_NAME, O_CREAT|O_RDWR, S_IRWXO|S_IRWXG|S_IRWXU)) == -1 )
	{
        	perror("shm_open");
        	return 1;
    	}
	if ( ftruncate(shm, gdatSHARED_MEMORY_OBJECT_SIZE+1) == -1 ) 
	{
		perror("ftruncate");
		return 2;
        }
	//семафор - создание
	if ( (sem = sem_open(gdatSEMAPHORE_NAME, O_CREAT, 0777, 0)) == SEM_FAILED ) 
	{
		perror("sem_open");
		return 3;
	}
	sem_post(sem);
	//mutex create
        if(!(pthread_mutex_init(&gdmemMutex,NULL) == 0))
                return 4;
	pthread_create(&hgdmemnProcess,NULL,(void*) gdmemProcess,NULL);
	//
	return 0;
}

//процесс доступа к разделяемой памяти
void gdmemProcess(void)
{
	while(1)
	{
		pthread_mutex_lock(&gdmemMutex);
		sem_wait(sem);
		//
		if ( (addr = mmap(0, gdatSHARED_MEMORY_OBJECT_SIZE+1, PROT_WRITE|PROT_READ, MAP_SHARED, shm, 0)) == (GDATA1*)-1 )
		{
        		perror("mmap");
        		break;
    		}
		//чтение задания
		gdat.timeSonar			= addr->timeSonar;
		if(gdat.scntrl	!= _scntrl_servoANDmotors)
		{
			gdat.wrmotors[0]		= addr->wrmotors[0];
			gdat.wrmotors[1]		= addr->wrmotors[1];
			gdat.wrspeed_motors[0]		= addr->wrspeed_motors[0];
			gdat.wrspeed_motors[1]		= addr->wrspeed_motors[1];
			gdat.wrservo[0]			= addr->wrservo[0];
			gdat.wrservo[1]			= addr->wrservo[1];
			gdat.wrservo_speed[0]		= addr->wrservo_speed[0];
			gdat.wrservo_speed[1]		= addr->wrservo_speed[1];
			gdat.sonardistance		= addr->sonardistance;
			gdat.status1			= addr->status1;
		}
		gdat.scntrl			= addr->scntrl;
		//запись состояния и новых заданий
		addr->timeMotorANDservo		= gdat.timeMotorANDservo;
		addr->wrmotors[0]		= gdat.wrmotors[0];
		addr->wrmotors[1]		= gdat.wrmotors[1];
		addr->wrspeed_motors[0]		= gdat.wrspeed_motors[0];
		addr->wrspeed_motors[1]		= gdat.wrspeed_motors[1];
		addr->rdmotors[0]		= gdat.rdmotors[0];
		addr->rdmotors[1]		= gdat.rdmotors[1];
		addr->rdservo[0]		= gdat.rdservo[0];
		addr->rdservo[1]		= gdat.rdservo[1];
		addr->status1			|= gdat.status1;
		addr->scntrl			= gdat.scntrl;
		//
		sem_post(sem);
		pthread_mutex_unlock(&gdmemMutex);
		usleep(_gmemSleep);
	}
	pthread_exit(0);
}



